# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2011 <Davide Vescovini> <davide.vescovini@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

################################################################################
############# IMPORTAZIONE MODULI ##############################################
################################################################################
from gi.repository import Gtk
from preventares_lib.helpers import get_builder
import gettext
from gettext import gettext as _
gettext.textdomain('preventares')

################################################################################
############# DIALOG ###########################################################
################################################################################
class ModifyDialog(Gtk.Dialog):
    __gtype_name__ = "ModifyDialog"

    def __new__(cls, liststore_capitoli=None, liststore_categorie=None,
                liststore_appalto=None, liststore_um=None):
        """Special static method that's automatically called by Python when 
        constructing a new instance of this class.
        
        Returns a fully instantiated ModifyDialog object.
        """
        builder = get_builder('ModifyDialog')
        new_object = builder.get_object('modify_dialog')
        new_object.finish_initializing(builder, 
                                       liststore_capitoli,
                                       liststore_categorie,
                                       liststore_appalto,
                                       liststore_um)
        return new_object

    def __init__(self, liststore_capitoli=None, liststore_categorie=None,
                 liststore_appalto=None, liststore_um=None):
        """""" 
        pass

    def finish_initializing(self, builder,
                            liststore_capitoli, 
                            liststore_categorie, 
                            liststore_appalto,
                            liststore_um):
        """Called when we're finished initializing.

        finish_initalizing should be called after parsing the ui definition
        and creating a ModifyDialog object with it in order to
        finish initializing the start of the new ModifyDialog
        instance.
        """
        # Get a reference to the builder and set up the signals.
        self.builder = builder
        self.builder.connect_signals(self)
        self.liststore_capitoli = liststore_capitoli
        self.liststore_categorie = liststore_categorie
        self.liststore_appalto = liststore_appalto
        #####################################################################
        # Imposta un riferimento agli eltri elementi dell'interfaccia grafica.
        #####################################################################
        self.modifica_computo = False
        self.scambio_costi = None
        self.variazione_prezzi = False
        #####################################################################
        # Imposta un riferimento agli eltri elementi dell'interfaccia grafica.
        #####################################################################
        # Tab Capitoli
        self.checkbutton_capitoli = self.builder.get_object("checkbutton10")
        cell = Gtk.CellRendererText()
        self.box_supercapitolo = self.builder.get_object("combobox1")
        self.box_supercapitolo.pack_start(cell, True)
        self.box_supercapitolo.add_attribute(cell, 'text', 1)
        self.box_supercapitolo.set_model(liststore_capitoli[0])
        self.box_supercapitolo.set_sensitive(False)
        self.box_capitolo = self.builder.get_object("combobox2")
        self.box_capitolo.pack_start(cell, True)
        self.box_capitolo.add_attribute(cell, 'text', 1)
        self.box_capitolo.set_model(liststore_capitoli[1])
        self.box_capitolo.set_sensitive(False)
        self.box_subcapitolo = self.builder.get_object("combobox3")
        self.box_subcapitolo.pack_start(cell, True)
        self.box_subcapitolo.add_attribute(cell, 'text', 1)
        self.box_subcapitolo.set_model(liststore_capitoli[2])
        self.box_subcapitolo.set_sensitive(False)
        # Tab Categorie
        self.checkbutton_categorie = self.builder.get_object("checkbutton11")
        self.box_supercategoria = self.builder.get_object("combobox6")
        self.box_supercategoria.pack_start(cell, True)
        self.box_supercategoria.add_attribute(cell, 'text', 1)
        self.box_supercategoria.set_model(liststore_categorie[0])
        self.box_supercategoria.set_sensitive(False)
        self.box_categoria = self.builder.get_object("combobox7")
        self.box_categoria.pack_start(cell, True)
        self.box_categoria.add_attribute(cell, 'text', 1)
        self.box_categoria.set_model(liststore_categorie[1])
        self.box_categoria.set_sensitive(False)
        self.box_subcategoria = self.builder.get_object("combobox8")
        self.box_subcategoria.pack_start(cell, True)
        self.box_subcategoria.add_attribute(cell, 'text', 1)
        self.box_subcategoria.set_model(liststore_categorie[2])
        self.box_subcategoria.set_sensitive(False)
        # Tab Analisi
        self.checkbutton_um = self.builder.get_object("checkbutton1")
        self.checkbutton_ricarico = self.builder.get_object("checkbutton2")
        self.checkbutton_sicurezza = self.builder.get_object("checkbutton3")
        self.checkbutton_tempo_inst = self.builder.get_object("checkbutton4")
        self.spinbutton_ricarico = self.builder.get_object("spinbutton1")
        self.spinbutton_sicurezza = self.builder.get_object("spinbutton2")
        self.entry_tempo_inst = self.builder.get_object("entry1")
        self.spinbutton_ricarico.set_sensitive(False)
        self.spinbutton_sicurezza.set_sensitive(False)
        self.entry_tempo_inst.set_sensitive(False)
        self.entry_tempo_inst.set_text('0')
        table = builder.get_object("table1")
        self.comboboxentry_um = Gtk.ComboBox.new_with_model_and_entry(liststore_um)
        self.comboboxentry_um.set_entry_text_column(0)
        table.attach(self.comboboxentry_um, 1, 2, 0, 1)
        self.comboboxentry_um.set_sensitive(False)
        self.comboboxentry_um.show()
        # Tab Costi
        self.checkbutton_costo_mat = self.builder.get_object("checkbutton5")
        self.checkbutton_costo1 = self.builder.get_object("checkbutton6")
        self.checkbutton_costo2 = self.builder.get_object("checkbutton7")
        self.checkbutton_costo3 = self.builder.get_object("checkbutton8")
        self.checkbutton_costo4 = self.builder.get_object("checkbutton9")
        self.entry_costo_mat = self.builder.get_object("entry2")
        self.entry_costo1 = self.builder.get_object("entry3")
        self.entry_costo2 = self.builder.get_object("entry4")
        self.entry_costo3 = self.builder.get_object("entry5")
        self.entry_costo4 = self.builder.get_object("entry6")
        self.box_costo_partenza = self.builder.get_object("combobox4")
        self.box_costo_arrivo = self.builder.get_object("combobox5")
        self.entry_costo_mat.set_text('0')
        self.entry_costo1.set_text('0')
        self.entry_costo2.set_text('0')
        self.entry_costo3.set_text('0')
        self.entry_costo4.set_text('0')
        self.entry_costo_mat.set_sensitive(False)
        self.entry_costo1.set_sensitive(False)
        self.entry_costo2.set_sensitive(False)
        self.entry_costo3.set_sensitive(False)
        self.entry_costo4.set_sensitive(False)
        # Tab Aumenti e Diminuzioni
        self.checkbutton_var_costi = self.builder.get_object("checkbutton12")
        self.checkbutton_var_tempi = self.builder.get_object("checkbutton13")
        self.entry_perc_var = self.builder.get_object("entry7")
        self.entry_perc_var.set_sensitive(False)
        self.entry_perc_var.set_text('0')
        # Tab Tipologie di appalto
        self.checkbutton_tip_appalto = self.builder.get_object("checkbutton14")
        self.box_tip_appalto = self.builder.get_object("combobox9")
        self.box_tip_appalto.pack_start(cell, True)
        self.box_tip_appalto.add_attribute(cell, 'text', 0)
        self.box_tip_appalto.set_model(liststore_appalto[0])
        self.box_tip_appalto.set_sensitive(False)
        self.checkbutton_cat_appalto = self.builder.get_object("checkbutton15")
        self.box_cat_appalto = self.builder.get_object("combobox10")
        self.box_cat_appalto.pack_start(cell, True)
        self.box_cat_appalto.add_attribute(cell, 'text', 0)
        self.box_cat_appalto.set_model(liststore_appalto[1])
        self.box_cat_appalto.set_sensitive(False)
################################################################################
###  PULSANTI OK / ANNULLA #####################################################
################################################################################
    def ok(self, widget, data=None):
        """The user has elected to save the changes.
        Called before the dialog returns Gtk.ResponseType.OK from run()."""
        # Tab Capitoli
        if self.box_supercapitolo.get_active() != -1:
            model = self.box_supercapitolo.get_model()
            iter = self.box_supercapitolo.get_active_iter()
            supercapitolo = model.get_value(iter, 0)
        else: supercapitolo= None
        if self.box_capitolo.get_active() != -1:
            model = self.box_capitolo.get_model()
            iter = self.box_capitolo.get_active_iter()
            capitolo = model.get_value(iter, 0)
        else: capitolo= None
        if self.box_subcapitolo.get_active() != -1:
            model = self.box_subcapitolo.get_model()
            iter = self.box_subcapitolo.get_active_iter()
            subcapitolo = model.get_value(iter, 0)
        else: subcapitolo= None
        # Tab Categorie
        if self.box_supercategoria.get_active() != -1:
            model = self.box_supercategoria.get_model()
            iter = self.box_supercategoria.get_active_iter()
            supercategoria = model.get_value(iter, 0)
        else: supercategoria= None
        if self.box_categoria.get_active() != -1:
            model = self.box_categoria.get_model()
            iter = self.box_categoria.get_active_iter()
            categoria = model.get_value(iter, 0)
        else: categoria= None
        if self.box_subcategoria.get_active() != -1:
            model = self.box_subcategoria.get_model()
            iter = self.box_subcategoria.get_active_iter()
            subcategoria = model.get_value(iter, 0)
        else: subcategoria= None
        # Tab Analisi
        if self.comboboxentry_um.get_sensitive():
            um = self.comboboxentry_um.get_child().get_text()
        else: um = None
        if self.spinbutton_ricarico.get_sensitive():
            ric= self.spinbutton_ricarico.get_value()
        else: ric = None
        if self.spinbutton_sicurezza.get_sensitive():
            sicurezza= self.spinbutton_sicurezza.get_value()
        else: sicurezza = None
        if self.entry_tempo_inst.get_sensitive():
            temp= int(self.entry_tempo_inst.get_text())
        else: temp = None
        # Tab Costi
        if self.entry_costo_mat.get_sensitive():
            mat = float(self.entry_costo_mat.get_text())
        else: mat = None
        if self.entry_costo1.get_sensitive():
            costi1 = float(self.entry_costo1.get_text())
        else: costi1 = None
        if self.entry_costo2.get_sensitive():
            costi2 = float(self.entry_costo2.get_text())
        else: costi2 = None
        if self.entry_costo3.get_sensitive():
            costi3 = float(self.entry_costo3.get_text())
        else: costi3 = None
        if self.entry_costo4.get_sensitive():
            costi4 = float(self.entry_costo4.get_text())
        else: costi4 = None
        # Tab Aumenti e Diminuzioni
        if self.entry_perc_var.get_sensitive():
            perc_var = float(self.entry_perc_var.get_text())
            varia_costi= self.checkbutton_var_costi.get_active()
            varia_tempi= self.checkbutton_var_tempi.get_active()
        else:
            perc_var = 0
            varia_costi = False
            varia_tempi = False
        # Tab Tipologie di appalto
        if self.box_tip_appalto.get_active() != -1:
            model = self.box_tip_appalto.get_model()
            iter = self.box_tip_appalto.get_active_iter()
            tip_appalto = model.get_value(iter, 0)
        else: tip_appalto= None
        if self.box_cat_appalto.get_active() != -1:
            model = self.box_cat_appalto.get_model()
            iter = self.box_cat_appalto.get_active_iter()
            cat_appalto = model.get_value(iter, 0)
        else: cat_appalto= None
        # costruisco la lista dei parametri da passare alla funzione di aggionamento in ComputoWindow
        self.parametri = [supercapitolo, capitolo, subcapitolo, um, ric, temp, mat,
                          sicurezza, costi1, costi2, costi3, costi4, supercategoria,
                          categoria, subcategoria, perc_var, varia_costi, 
                          varia_tempi, tip_appalto, cat_appalto]
        # verifica se sono richieste modifiche alla tabella computo
        self.modifica_computo = (self.checkbutton_categorie.get_active() or 
                                   self.checkbutton_tip_appalto.get_active() or
                                   self.checkbutton_cat_appalto.get_active())
        # scambio dei costi
        if self.box_costo_partenza.get_active() != -1 and self.box_costo_arrivo.get_active() != -1:
            costo_partenza = self.box_costo_partenza.get_active()
            costo_arrivo = self.box_costo_arrivo.get_active()
            self.scambio_costi = [costo_partenza, costo_arrivo]
        else:
            costo_partenza = None
            costo_arrivo = None
            self.scambio_costi = None
        # Aumenti e Diminuzioni
        if perc_var != 0: self.variazione_prezzi = True
        else: self.variazione_prezzi = False
        # nascondi la finestra
        self.hide()

    def cancel(self, widget, data=None):
        """The user has elected cancel changes.

        Called before the dialog returns Gtk.ResponseType.CANCEL for run()
        """
        pass
################################################################################
###  CAPITOLI - SEZIONE TAB PER MOD. CAPITOLI ##################################
################################################################################
    def Attiva_mod_capitoli(self, widget, data=None):
        self.box_supercapitolo.set_sensitive(widget.get_active())
        self.box_supercapitolo.set_active(-1)
        self.box_capitolo.set_sensitive(widget.get_active())
        self.box_capitolo.set_active(-1)
        self.box_subcapitolo.set_sensitive(widget.get_active())
        self.box_subcapitolo.set_active(-1)
################################################################################
###  CAPITOLI - SEZIONE TAB PER MOD. CAPITOLI ##################################
################################################################################
    def Attiva_mod_categorie(self, widget, data=None):
        self.box_supercategoria.set_sensitive(widget.get_active())
        self.box_supercategoria.set_active(-1)
        self.box_categoria.set_sensitive(widget.get_active())
        self.box_categoria.set_active(-1)
        self.box_subcategoria.set_sensitive(widget.get_active())
        self.box_subcategoria.set_active(-1)
################################################################################
###  ANALISI - SEZIONE TAB PER MOD. ANALISI ####################################
################################################################################
    def Attiva_um(self, widget, data=None):
        self.comboboxentry_um.set_sensitive(widget.get_active())
    def Attiva_ricarico(self, widget, data=None):
        self.spinbutton_ricarico.set_sensitive(widget.get_active())
    def Attiva_sicurezza(self, widget, data=None):
        self.spinbutton_sicurezza.set_sensitive(widget.get_active())
    def Attiva_tempo_inst(self, widget, data=None):
        self.entry_tempo_inst.set_sensitive(widget.get_active())
################################################################################
###  COSTI MATERIALI - SEZIONE TAB PER MOD. COSTI ##############################
################################################################################
    def Attiva_costo_mat(self, widget, data=None):
        self.entry_costo_mat.set_sensitive(widget.get_active())
    def Attiva_costo1(self, widget, data=None):
        self.entry_costo1.set_sensitive(widget.get_active())
    def Attiva_costo2(self, widget, data=None):
        self.entry_costo2.set_sensitive(widget.get_active())
    def Attiva_costo3(self, widget, data=None):
        self.entry_costo3.set_sensitive(widget.get_active())
    def Attiva_costo4(self, widget, data=None):
        self.entry_costo4.set_sensitive(widget.get_active())
################################################################################
###  VARIAZIONE COSTI - SEZIONE TAB PER MOD. AUMENTI/DIMINUZIONI ###############
################################################################################
    def Attiva_perc_var(self, widget, data=None):
        if self.checkbutton_var_costi.get_active() or self.checkbutton_var_tempi.get_active():
            self.entry_perc_var.set_sensitive(True)
        else:
            self.entry_perc_var.set_sensitive(False)
################################################################################
###  CAPITOLI - SEZIONE TAB PER MOD. CAPITOLI ##################################
################################################################################
    def Attiva_box_tip_appalto(self, widget, data=None):
        self.box_tip_appalto.set_sensitive(widget.get_active())
        self.box_tip_appalto.set_active(-1)
    def Attiva_box_cat_appalto(self, widget, data=None):
        self.box_cat_appalto.set_sensitive(widget.get_active())
        self.box_cat_appalto.set_active(-1)
################################################################################
###  VALIDAZIONE DELL'INPUT DELL'UTENTE ########################################
################################################################################
    def verifica_input_utente (self, widget, data=None):
        """Verifica se il dato immesso è valido o avvisa l'utente tramite un messaggio di errore
           questo metodo è valido solamente per oggetti che supportano il metodo .get_text() (es. Gtk.Entry)"""
        text = widget.get_text()
        text = text.replace(',', '.')
        try:
            dato = float(text)
            widget.set_text(text)
        except ValueError:
            if not self.message(self, "errore", "Valore non corretto. Immettere una numero decimale o intero"):
                elenco_caratteri_ok = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '.']
                for carattere in list(text):
                    if carattere not in elenco_caratteri_ok:
                        text = text.replace(carattere, '')
                widget.grab_focus()
                widget.set_text(text)
                try:
                    dato = float(text)
                except ValueError:
                    dato = 0.0
                    widget.set_text('0.0')
        return dato

################################################################################
###  FINESTRA MESSAGGI UTENTE ##################################################
################################################################################
    def message(self, widget, tipo, testo, data=None):
        """display a message windows"""
        buttons = Gtk.BUTTONS_OK_CANCEL
        if tipo == "info":
           tipo = Gtk.MessageType.INFO
           buttons = Gtk.ButtonsType.CLOSE
        elif tipo == "avviso":
           tipo = Gtk.MessageType.WARNING
        elif tipo == "domanda":
           tipo = Gtk.MessageType.QUESTION
        elif tipo == "errore":
           tipo = Gtk.MessageType.ERROR
           buttons = Gtk.ButtonsType.CLOSE
        else:
           tipo == Gtk.MessageType.INFO
           buttons = Gtk.ButtonsType.CLOSE
        message = Gtk.MessageDialog(parent=None, flags=0, type=tipo, buttons = buttons, message_format=testo)
        message.format_secondary_text(_("Premere un pulsante per continuare"))
        response = message.run()
        if response == Gtk.ResponseType.OK:
           response = True
        else:
           response = False 
        message.destroy()
        return response
################################################################################
###  NON MODIFICARE ############################################################
################################################################################
if __name__ == "__main__":
    dialog = ModifyDialog()
    dialog.show()
    Gtk.main()
